%% Function to perform Out-of-sample reconstruction accroding to technique specified

function Xnew = linearReconstruction(X,Y,Ynew,nn_size)

        % Find neighbourhoods
        idx = knnsearch(Y,Ynew,'K',nn_size);
                  
        % Construct weights and compute OOS
        tol = 1e-3;
        W = zeros(nn_size,size(Ynew,1));
        Xnew = zeros(size(Ynew,1),size(X,2));
        for ii=1:size(Ynew,1)
            z = Y(idx(ii,:),:)-repmat(Ynew(ii,:),nn_size,1); % shift ith pt to origin
            C = z*z';                                        % local covariance
            C = C + eye(nn_size,nn_size)*tol*trace(C);       % regularlization (K>D)
            W(:,ii) = C\ones(nn_size,1);                           % solve Cw=1
            W(:,ii) = W(:,ii)/sum(W(:,ii));                  % enforce sum(w)=1
            
            Xnew(ii,:) = W(:,ii)'*X(idx(ii,:),:);
        end        
end